class KPanelApplet

# class KPanelApplet | KDE Panel Applet class. More...
Definition | `#include <kpanelapplet.h>`
Inherits | QFrame (qt) [public ]
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Types

- enum Type { Normal = 0, Stretch }
- enum Action { About = 1, Help = 2, Preferences = 4, ReportBug = 8 }
- enum Position { pLeft = 0, pRight, pTop, pBottom }
- enum Alignment { LeftTop = 0, Center, RightBottom }
- enum Direction { Up = 0, Down, Left, Right }

#### Public Methods

- KPanelApplet (const QString& configFile, Type t = Normal, int actions = 0, QWidget *parent = 0, const char *name = 0, WFlags f = 0)
- ~KPanelApplet ()
- virtual int widthForHeight (int height) const
- virtual int heightForWidth (int width) const
- KConfig* config () const
- Type type () const
- int actions () const
- virtual void action ( Action a )
- void setPosition ( Position p )
- void setAlignment ( Alignment a )

#### Signals

- void updateLayout ()
- void requestFocus ()

#### Protected Methods

- virtual void about ()
- virtual void help ()
- virtual void preferences ()
- virtual void reportBug ()
- Orientation orientation () const
- Position position () const
- Alignment alignment () const
- virtual void positionChange ( Position p )
- virtual void alignmentChange ( Alignment )
- virtual void orientationChange ( Orientation )
- Direction popupDirection ()
- virtual void popupDirectionChange ( Direction )
- virtual void virtual_hook ( int id, void* data )

#### Protected Members

- Forward KPanelAppletPrivate
- KPanelAppletPrivate *d

## Detailed Description

Implement a panel applet.

Panel applets

- Are small applications living in the KDE panel.
- Are implemented as DSOs (Dynamic Shared Objects).

Note: For security and stability reasons the panel won't load untrusted third party applets directly into its namespace but via an external wrapper process.

The panel locates available applets by searching for applet desktop files in (ALL_KDEDIRS)/share/apps/kicker/applets. Every panel applet should install a desktop file there to be recognised by the panel.

Besides standard keys like "Name", "Comment" and "Icon" there are two panel applet specific keys:

### X-KDE-Library

Used by the panel to locate the applet DSO (Dynamic Shared Object) Example: X-KDE-Library=libexampleapplet

### X-KDE-UniqueApplet

Similar to KApplication and KUniqueApplication there are two types of panel applets. Use unique applets when it makes no sence to run more than one instance of a applet in the panel. A good example for unique applets is the taskbar applet. Use normal applets when you need instance specific configuration. An example is the koolclock applet where you might want to run two instances in your panel, one configured as analog clock, the other one as digital clock. X-KDE-UniqueApplet is a boolean key which defaults to "false". Example: X-KDE-UniqueApplet=true

Back to panel applet DSOs, the following conventions are used for KDE: Name: libapplet.la LDFLAGS: -module -no-undefined

To implement a panel applet it is not enough to write a class inheriting from KPanelApplet but you also have to provide a factory function in your DSO. A sample factory function could look like this:

     extern "C"
     {
         KPanelApplet* init(QWidget *parent, const QString& configFile)
         {
             KGlobal::locale()->insertCatalogue("exampleapplet");
             return new ExampleApplet(configFile, KPanelApplet::Normal,
                           KPanelApplet::About | KPanelApplet::Help | KPanelApplet::Preferences,
                           parent, "exampleapplet");
         }
     }

Note: Don't change the factory function signature or the panel will fail to load your applet.

enum Type { Normal = 0, Stretch } | ### Type

This enum describes the type of the applet.

enum Action { About = 1, Help = 2, Preferences = 4, ReportBug = 8 } | ### Action

This enum holds flags which can be ORed together to describe which items the context menu over the applet handle contains.

enum Position { pLeft = 0, pRight, pTop, pBottom } | ### Position

enum Alignment { LeftTop = 0, Center, RightBottom } | ### Alignment

enum Direction { Up = 0, Down, Left, Right } | ### Direction

KPanelApplet (const QString& configFile, Type t = Normal, int actions = 0, QWidget *parent = 0, const char *name = 0, WFlags f = 0) | ### KPanelApplet

Constructs a KPanelApplet just like any other widget.

Parameters:

configFile | The configFile handed over in the factory function.
Type | The applet type().
actions | Standard RMB menu actions supported by the applet (see action() ).
parent | The pointer to the parent widget handed over in the factory function.
name | A Qt object name for your applet.

~KPanelApplet () | ### ~KPanelApplet

Destructor.

int widthForHeight (int height) | ### widthForHeight

[const virtual]

Returns a suggested width for a given height.

Every applet should reimplement this function.

Depending on the panel orientation the height (horizontal panel) or the width (vertical panel) of the applets is fixed. The exact values of the fixed size component depend on the panel size.

On a horizontal panel the applet height is fixed, the panel will call widthForHeight(int height) with `height` equal to 'the fixed applet height' when laying out the applets.

The applet can now choose the other size component (width) based on the given height.

The width you return is granted.

int heightForWidth (int width) | ### heightForWidth

[const virtual]

Every applet should reimplement this function.

Depending on the panel orientation the height (horizontal panel) or the width (vertical panel) of the applets is fixed. The exact values of the fixed size component depend on the panel size.

On a vertical panel the applet width is fixed, the panel will call heightForWidth(int width) with `width` equal to 'the fixed applet width' when layint out the applets.

The applet can now choose the other size component (height) based on the given width.

The height you return is granted.

Returns: A suggested height for a given width.

KConfig* config () | ### config

[const]

Always use this KConfig object to save/load your applets configuration.

For unique applets this config object will write to a config file called rc in the users local KDE directory.

For normal applets this config object will write to a instance specific config file called rc in the users local KDE directory.

Type type () | ### type

[const]

Returns: Type indicating the applet's type. Type

int actions () | ### actions

[const]

Returns: int indicating the supported RMB menu actions. Action

void action ( Action a ) | ### action

[virtual]

Generic action dispatcher. Called when the user selects an item from the applets RMB menu.

Reimplement this function to handle actions.

For About, Help, Preferences and ReportBug, use the convenience handlers ref about(), help(), preferences(), reportBug()

void setPosition ( Position p ) | ### setPosition

void setAlignment ( Alignment a ) | ### setAlignment

void updateLayout () | ### updateLayout

[signal]

Emit this signal to make the panel relayout all applets, when you want to change your width (horizontal panel) or height (vertical panel).

The panel is going to relayout all applets based on their widthForHeight(int height) (horizontal panel) or heightForWidth(int width) (vertical panel).

Please note that the panel may change the applets location if the new widthForHeight(int height) (horizontal panel) or heightForWidth(int width) (vertical panel) does not fit into the current panel layout.

void requestFocus () | ### requestFocus

[signal]

Request keyboard focus from the panel.

void about () | ### about

[protected virtual]

Is called when the user selects "About" from the applet's RMB menu. Reimplement this function to launch a about dialog.

Note that this is called only when your applet supports the About action. See Action and KPanelApplet().

void help () | ### help

[protected virtual]

Is called when the user selects "Help" from the applet's RMB menu. Reimplement this function to launch a manual or help page.

Note that this is called only when your applet supports the Help action. See Action and KPanelApplet().

void preferences () | ### preferences

[protected virtual]

Is called when the user selects "Preferences" from the applet's RMB menu. Reimplement this function to launch a preferences dialog or kcontrol module.

Note that this is called only when your applet supports the preferences action. See Action and KPanelApplet().

void reportBug () | ### reportBug

[protected virtual]

Is called when the user selects "Report bug" from the applet's RMB menu. Reimplement this function to launch a bug reporting dialog.

Note that this is called only when your applet supports the ReportBug action. See Action and KPanelApplet()

Orientation orientation () | ### orientation

[protected const]

Returns: the applet's orientation. (horizontal or vertical)

Position position () | ### position

[protected const]

Returns: the applet's position. (top, left, bottom, or right)

Alignment alignment () | ### alignment

[protected const]

Returns: the applet's alignment. (top/left, center, or bottom/right)

void positionChange ( Position p ) | ### positionChange

[protected virtual]

The panel on which this applet resides has changed its position. Reimplement this change handler in order to adjust the look of your applet.

void alignmentChange ( Alignment ) | ### alignmentChange

[protected virtual]

The panel on which this applet resides has changed its alignment. Reimplement this change handler in order to adjust the look of your applet.

void orientationChange ( Orientation ) | ### orientationChange

[protected virtual]

The orientation changed to `orientation`. Reimplement this change handler in order to adjust the look of your applet.

Direction popupDirection () | ### popupDirection

[protected]

You may need this if you want to popup menus at the right position.

See popupDirectionChange()

void popupDirectionChange ( Direction ) | ### popupDirectionChange

[protected virtual]

The popup direction changed to `direction`. Reimplement this change handler in order to adjust the look of your applet.

void virtual_hook ( int id, void* data ) | ### virtual_hook

[protected virtual]

KPanelAppletPrivate * d | ### d

[protected]

- Author: Matthias Elter
- Generated: root on macppc.ports.openbsd.org on Sat Sep 6 10:36:37 2003, using kdoc 2.0a54.